! @(#)system.inc 1.3 (Sun Microsystems, Inc.) 05/04/15
!
!    Copyright  1998, 2004 Sun Microsystems, Inc.
!    All rights reserved.
!

      INTERFACE FREE
	SUBROUTINE FREEP(ADDRESS)
	  POINTER (ADDRESS, X)
	END SUBROUTINE
	SUBROUTINE FREE64I(ADDRESS)
	  INTEGER(KIND=8) ADDRESS
	END SUBROUTINE
      END INTERFACE

      INTERFACE MALLOC
	INTEGER(KIND=8) FUNCTION MALLOC8I(SIZE)
	  INTEGER(KIND=1) SIZE
	END FUNCTION
	INTEGER(KIND=8) FUNCTION MALLOC16I(SIZE)
	  INTEGER(KIND=2) SIZE
	END FUNCTION
	INTEGER(KIND=8) FUNCTION MALLOC32I(SIZE)
	  INTEGER(KIND=4) SIZE
	END FUNCTION
	INTEGER(KIND=8) FUNCTION MALLOC64I(SIZE)
	  INTEGER(KIND=8) SIZE
	END FUNCTION
      END INTERFACE

      INTERFACE
      SUBROUTINE ABORT()
      END SUBROUTINE ABORT
      END INTERFACE

      INTERFACE
      FUNCTION ACCESS(NAME, MODE)
      INTEGER(4) ACCESS
      CHARACTER*(*) NAME, MODE
      END FUNCTION ACCESS
      END INTERFACE

      INTERFACE
      FUNCTION ALARM(TIME, SUBRTN)
      INTEGER(4) ALARM
      INTEGER(4) TIME
      EXTERNAL SUBRTN
      END FUNCTION ALARM
      END INTERFACE

      INTERFACE
      FUNCTION BESJ0(X)
      REAL(4) BESJ0
      REAL(4) X
      END FUNCTION BESJ0
      END INTERFACE

      INTERFACE
      FUNCTION BESJ1(X)
      REAL(4) BESJ1
      REAL(4) X
      END FUNCTION BESJ1
      END INTERFACE

      INTERFACE
      FUNCTION BESJN(N, X)
      REAL(4) BESJN
      INTEGER(4) N
      REAL(4) X
      END FUNCTION BESJN
      END INTERFACE

      INTERFACE
      FUNCTION BESY0(X)
      REAL(4) BESY0
      REAL(4) X
      END FUNCTION BESY0
      END INTERFACE

      INTERFACE
      FUNCTION BESY1(X)
      REAL(4) BESY1
      REAL(4) X
      END FUNCTION BESY1
      END INTERFACE

      INTERFACE
      FUNCTION BESYN(N, X)
      REAL(4) BESYN
      INTEGER(4) N
      REAL(4) X
      END FUNCTION BESYN
      END INTERFACE

      INTERFACE
      SUBROUTINE BIC (N, W)
      INTEGER(4), INTENT(IN) :: N
      INTEGER(4), INTENT(OUT) :: W
      END SUBROUTINE BIC
      END INTERFACE

      INTERFACE
      SUBROUTINE BIS (N, W)
      INTEGER(4), INTENT(IN) :: N
      INTEGER(4), INTENT(OUT) :: W
      END SUBROUTINE BIS
      END INTERFACE

      LOGICAL(2) BITEST

      LOGICAL(4) BJTEST

      LOGICAL(8) BKTEST

      LOGICAL(4) BTEST

      INTERFACE
      FUNCTION CHDIR (DIRNAME)
      INTEGER(4) CHDIR
      CHARACTER*(*), INTENT(IN) :: DIRNAME
      END FUNCTION CHDIR
      END INTERFACE

      INTERFACE
      FUNCTION CHMOD (NAME, MODE)
      INTEGER(4) CHMOD
      CHARACTER*(*), INTENT(IN) :: NAME
      CHARACTER*(*), INTENT(IN) :: MODE
      END FUNCTION CHMOD
      END INTERFACE

      INTERFACE
      FUNCTION CTIME (N)
      CHARACTER*24 CTIME
      INTEGER(4), INTENT(INOUT) :: N
      END FUNCTION CTIME
      END INTERFACE

      INTERFACE
      FUNCTION CTIME64 (N)
      CHARACTER*24 CTIME64
      INTEGER(8), INTENT(INOUT) :: N
      END FUNCTION CTIME64
      END INTERFACE

      INTERFACE
      SUBROUTINE DATE( STR )
      CHARACTER*9, INTENT(OUT) :: STR
      END SUBROUTINE DATE
      END INTERFACE

      INTERFACE
      FUNCTION DBESJ0(X)
      REAL(8) DBESJ0
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESJ0
      END INTERFACE

      INTERFACE
      FUNCTION DBESJ1(X)
      REAL(8) DBESJ1
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESJ1
      END INTERFACE

      INTERFACE
      FUNCTION DBESJN(N,X)
      REAL(8) DBESJN
      INTEGER(4), INTENT(IN) :: N
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESJN
      END INTERFACE

      INTERFACE
      FUNCTION DBESY0(X)
      REAL(8) DBESY0
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESY0
      END INTERFACE

      INTERFACE
      FUNCTION DBESY1(X)
      REAL(8) DBESY1
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESY1
      END INTERFACE

      INTERFACE
      FUNCTION DBESYN(N,X)
      REAL(8) DBESYN
      INTEGER(4), INTENT(IN) :: N
      REAL(8), INTENT(IN) :: X
      END FUNCTION DBESYN
      END INTERFACE

      INTERFACE
      FUNCTION DERF(X)
      REAL(8) DERF
      REAL(8), INTENT(IN) :: X
      END FUNCTION DERF
      END INTERFACE

      INTERFACE
      FUNCTION DERFC(X)
      REAL(8) DERFC
      REAL(8), INTENT(IN) :: X
      END FUNCTION DERFC
      END INTERFACE

      INTERFACE
      FUNCTION DFLMAX()
      REAL(8) DFLMAX
      END FUNCTION DFLMAX
      END INTERFACE

      INTERFACE
      FUNCTION DFLMIN()
      REAL(8) DFLMIN
      END FUNCTION DFLMIN
      END INTERFACE

      INTERFACE
      FUNCTION DRAND(I)
      REAL(8) DRAND
      INTEGER(4), INTENT(IN) :: I
      END FUNCTION DRAND
      END INTERFACE

      INTERFACE
      FUNCTION DTIME(TIME)
      REAL(4) DTIME
      REAL(4), INTENT(OUT) :: TIME(2)
      END FUNCTION DTIME
      END INTERFACE

      INTERFACE
      SUBROUTINE EF1ASC( A, LA, B, LB )
      CHARACTER(*), INTENT(OUT) :: A
      CHARACTER(*), INTENT(IN) :: B
      INTEGER(4), INTENT(IN) :: LA
      INTEGER(4), INTENT(IN) :: LB
      END SUBROUTINE EF1ASC
      END INTERFACE

      INTERFACE
      FUNCTION EF1CMC( A, LA, B, LB )
      INTEGER(4) EF1CMC
      CHARACTER*(*), INTENT(IN) :: A
      CHARACTER*(*), INTENT(IN) :: B
      INTEGER(4), INTENT(IN) :: LA
      INTEGER(4), INTENT(IN) :: LB
      END FUNCTION EF1CMC
      END INTERFACE

      INTERFACE
      FUNCTION ERF(X)
      REAL(4) ERF
      REAL(4), INTENT(IN) :: X
      END FUNCTION ERF
      END INTERFACE

      INTERFACE
      FUNCTION ERFC(X)
      REAL(4) ERFC
      REAL(4), INTENT(IN) :: X
      END FUNCTION ERFC
      END INTERFACE

      INTERFACE
      FUNCTION ETIME (TIME)
      REAL(4) ETIME
      REAL(4), INTENT(OUT) :: TIME(2)
      END FUNCTION ETIME
      END INTERFACE

      INTERFACE
      SUBROUTINE EXIT (STATUS)
      INTEGER(4), INTENT(IN) :: STATUS
      END SUBROUTINE EXIT
      END INTERFACE

      INTERFACE
      FUNCTION FGETC (UNIT, CH)
      INTEGER(4) FGETC
      INTEGER(4), INTENT(IN) :: UNIT
      CHARACTER, INTENT(OUT) :: CH
      END FUNCTION FGETC
      END INTERFACE

      INTERFACE
      FUNCTION FLMAX ()
      REAL(4) FLMAX
      END FUNCTION FLMAX
      END INTERFACE

      INTERFACE
      FUNCTION FLMIN ()
      REAL(4) FLMIN
      END FUNCTION FLMIN
      END INTERFACE

      INTERFACE
      FUNCTION FLUSH (LUNIT)
      INTEGER(4) FLUSH
      INTEGER(4), INTENT(IN) :: LUNIT
      END FUNCTION FLUSH
      END INTERFACE

      INTERFACE
      FUNCTION FORK()
      INTEGER(4) FORK
      END FUNCTION
      END INTERFACE

      INTERFACE
      FUNCTION FPUTC (LUNIT, CHAR)
      INTEGER(4) FPUTC
      INTEGER(4), INTENT(IN) :: LUNIT
      CHARACTER, INTENT(IN) :: CHAR
      END FUNCTION FPUTC
      END INTERFACE

      INTERFACE
      FUNCTION FSEEK (LUNIT, OFFSET, FROM)
      INTEGER(4) FSEEK
      INTEGER(4), INTENT(IN) :: LUNIT
      INTEGER(8), INTENT(IN) :: OFFSET
      INTEGER(4), INTENT(IN) :: FROM
      END FUNCTION FSEEK
      END INTERFACE

      INTERFACE
      FUNCTION FSEEKO64 (LUNIT, OFFSET, FROM)
      INTEGER(4) FSEEKO64
      INTEGER(4), INTENT(IN) :: LUNIT
      INTEGER(8), INTENT(IN) :: OFFSET
      INTEGER(4), INTENT(IN) :: FROM
      END FUNCTION FSEEKO64
      END INTERFACE

      INTERFACE
      FUNCTION FSTAT (LUNIT, STATB)
      INTEGER(4) FSTAT
      INTEGER(4), INTENT(IN) :: LUNIT
      INTEGER(4), INTENT(OUT) :: STATB(13)
      END FUNCTION FSTAT
      END INTERFACE

      INTERFACE
      FUNCTION FSTAT64 (LUNIT, STATB)
      INTEGER(4) FSTAT64
      INTEGER(4), INTENT(IN) :: LUNIT
      INTEGER(8), INTENT(OUT) :: STATB(13)
      END FUNCTION FSTAT64
      END INTERFACE

      INTERFACE
      FUNCTION FTELL (LUNIT)
      INTEGER(4) FTELL
      INTEGER(4), INTENT(IN) :: LUNIT
      END FUNCTION FTELL
      END INTERFACE

      INTERFACE
      FUNCTION FTELLO64 (LUNIT)
      INTEGER(8) FTELLO64
      INTEGER(4), INTENT(IN) :: LUNIT
      END FUNCTION FTELLO64
      END INTERFACE

      INTERFACE
      SUBROUTINE GETARG( N, ARG )
      INTEGER(4), INTENT(IN) :: N
      CHARACTER*(*), INTENT(OUT) :: ARG
      END SUBROUTINE GETARG
      END INTERFACE

      INTERFACE
      FUNCTION GETCWD (DIRNAME)
      INTEGER(4) GETCWD
      CHARACTER*(*), INTENT(OUT) :: DIRNAME
      END FUNCTION GETCWD
      END INTERFACE

      INTERFACE
      SUBROUTINE GETENV(ENAME, EVALUE)
      CHARACTER*(*), INTENT(IN) ::  ENAME
      CHARACTER*(*), INTENT(INOUT) ::  EVALUE
      END SUBROUTINE GETENV
      END INTERFACE

      INTERFACE
      FUNCTION GETFD(UNITN)
      INTEGER(4) GETFD
      INTEGER(4), INTENT(IN) :: UNITN
      END FUNCTION GETFD
      END INTERFACE

      INTERFACE
      FUNCTION GETFILEP(LUNIT)
      INTEGER(8) GETFILEP
      INTEGER(4), INTENT(IN) :: LUNIT
      END FUNCTION GETFILEP
      END INTERFACE

      INTERFACE
      FUNCTION GETGID()
      INTEGER(4) GETGID
      END FUNCTION GETGID
      END INTERFACE

      INTERFACE
      FUNCTION GETHRTIME()
      INTEGER(8) GETHRTIME
      END FUNCTION GETHRTIME
      END INTERFACE

      INTERFACE
      FUNCTION GETHRVTIME()
      INTEGER(8) GETHRVTIME
      END FUNCTION GETHRVTIME
      END INTERFACE

      INTERFACE
      SUBROUTINE GETLOG( LNAME )
      CHARACTER*(*), INTENT(OUT) ::  LNAME
      END SUBROUTINE GETLOG
      END INTERFACE

      INTERFACE
      FUNCTION GETPID()
      INTEGER(4) GETPID
      END FUNCTION GETPID
      END INTERFACE

      INTERFACE
      FUNCTION GETUID()
      INTEGER(4) GETUID
      END FUNCTION GETUID
      END INTERFACE

      INTERFACE
      SUBROUTINE GMTIME (STIME, TARRAY)
      INTEGER(4), INTENT(INOUT) :: STIME
      INTEGER(4), INTENT(OUT) :: TARRAY(9)
      END SUBROUTINE GMTIME
      END INTERFACE

      INTERFACE
      SUBROUTINE GMTIME64 (STIME, TARRAY)
      INTEGER(8), INTENT(INOUT) :: STIME
      INTEGER(4), INTENT(OUT) :: TARRAY(9)
      END SUBROUTINE GMTIME64
      END INTERFACE

      INTERFACE
      FUNCTION HOSTNM( NAME )
      INTEGER(4) HOSTNM
      CHARACTER*(*), INTENT(OUT) ::  NAME
      END FUNCTION HOSTNM
      END INTERFACE

      INTEGER(4) IAND

      INTERFACE
      FUNCTION IARGC()
      INTEGER(4) IARGC
      END FUNCTION IARGC
      END INTERFACE

      INTEGER(4) IBCLR

      INTEGER(4) IBITS

      INTEGER(4) IBSET

      INTERFACE
      FUNCTION IERRNO()
      INTEGER(4) IERRNO
      END FUNCTION IERRNO
      END INTERFACE

      INTEGER(4) IEOR

      INTERFACE
      FUNCTION INMAX()
      INTEGER(4) INMAX
      END FUNCTION INMAX
      END INTERFACE

      INTEGER(4)  IOR

      INTERFACE
      FUNCTION IRAND( I )
      INTEGER(4) IRAND
      INTEGER(4), INTENT(IN) :: I
      END FUNCTION IRAND
      END INTERFACE

      INTERFACE
      FUNCTION ISATTY (LUNIT)
      LOGICAL(4) ISATTY
      INTEGER(4) LUNIT
      END FUNCTION ISATTY
      END INTERFACE

      INTEGER(4)  ISHFT

      INTEGER(4) ISHFTC

      INTEGER(4) JIAND

      INTEGER(4) JIBCLR

      INTERFACE
      FUNCTION LNBLNK( STR )
      INTEGER(8)  LNBLNK
      CHARACTER*(*), INTENT(IN) :: STR
      END FUNCTION LNBLNK
      END INTERFACE

      INTERFACE
      FUNCTION LONG( I )
      INTEGER(4) LONG
      INTEGER(2), INTENT(IN) :: I
      END FUNCTION LONG
      END INTERFACE

      INTERFACE
      FUNCTION KILL(PID, SIGNUM)
      INTEGER(4) KILL
      INTEGER(4), INTENT(IN) :: PID
      INTEGER(4), INTENT(IN) :: SIGNUM
      END FUNCTION KILL
      END INTERFACE

      INTERFACE
      FUNCTION LINK (NAME1, NAME2)
      INTEGER(4) LINK
      CHARACTER*(*), INTENT(IN) ::  NAME1
      CHARACTER*(*), INTENT(IN) ::  NAME2
      END FUNCTION LINK
      END INTERFACE

      INTERFACE
      FUNCTION LSTAT (NAME, STATB)
      INTEGER(4) LSTAT
      CHARACTER*(*) , INTENT(IN) ::NAME
      INTEGER(4), INTENT(OUT) :: STATB(13)
      END FUNCTION LSTAT
      END INTERFACE

      INTERFACE
      FUNCTION LSTAT64 (NAME, STATB)
      INTEGER(4) LSTAT64
      CHARACTER*(*), INTENT(IN) :: NAME
      INTEGER(8), INTENT(OUT) :: STATB(13)
      END FUNCTION LSTAT64
      END INTERFACE

      INTERFACE
      SUBROUTINE LTIME (STIME, TARRAY)
      INTEGER(4), INTENT(INOUT) :: STIME
      INTEGER(4), INTENT(OUT) :: TARRAY(9)
      END SUBROUTINE LTIME
      END INTERFACE

      INTERFACE
      SUBROUTINE LTIME64 (LLTIME, TARRAY)
      INTEGER(8), INTENT(INOUT) :: LLTIME
      INTEGER(4), INTENT(OUT) :: TARRAY(9)
      END SUBROUTINE LTIME64
      END INTERFACE

      INTEGER(4) NOT

      INTERFACE
      SUBROUTINE PERROR( STR )
      CHARACTER*(*), INTENT(IN) :: STR
      END SUBROUTINE PERROR
      END INTERFACE

      INTERFACE
      FUNCTION PUTC (CHAR)
      INTEGER(4) PUTC
      CHARACTER*1, INTENT(IN) :: CHAR
      END FUNCTION PUTC
      END INTERFACE

      INTERFACE
      FUNCTION RAN (I)
      REAL(4) RAN
      INTEGER(4), INTENT(INOUT) :: I
      END FUNCTION RAN
      END INTERFACE

      INTERFACE
      FUNCTION RAND(I)
      REAL(4) RAND
      INTEGER(4), INTENT(IN) :: I
      END FUNCTION RAND
      END INTERFACE

      INTERFACE
      FUNCTION RENAME(FROM, TO)
      INTEGER(4) RENAME
      CHARACTER*(*), INTENT(IN) ::  FROM
      CHARACTER*(*), INTENT(IN) ::  TO
      END FUNCTION RENAME
      END INTERFACE

      INTERFACE
      FUNCTION RINDEX( STR, SUBSTR )
      INTEGER(8) RINDEX
      CHARACTER*(*), INTENT(IN) ::  STR
      CHARACTER*(*), INTENT(IN) ::  SUBSTR
      END FUNCTION RINDEX
      END INTERFACE

      INTERFACE
      FUNCTION SECNDS( X )
      REAL(4)  SECNDS
      REAL(4), INTENT(IN) ::  X
      END FUNCTION SECNDS
      END INTERFACE

      INTERFACE
      SUBROUTINE SETBIT( N, W, S )
      INTEGER(4), INTENT(IN) :: N
      INTEGER(4), INTENT(OUT) :: W
      INTEGER(4), INTENT(IN) :: S
      END SUBROUTINE SETBIT
      END INTERFACE

      INTERFACE
      FUNCTION SHORT( I )
      INTEGER(4), INTENT(IN) :: I
      INTEGER(2)  SHORT
      END FUNCTION SHORT
      END INTERFACE

      INTERFACE
      FUNCTION SIGNAL(SIGNUM, PROC, FLAG)
      INTEGER(8) SIGNAL
      INTEGER(4), INTENT(IN) :: SIGNUM
      EXTERNAL PROC
      INTEGER(8), INTENT(IN) :: FLAG
      END FUNCTION SIGNAL
      END INTERFACE

      INTERFACE
      SUBROUTINE SLEEP(ITIME)
      INTEGER(4), INTENT(IN) :: ITIME
      END SUBROUTINE SLEEP
      END INTERFACE

      INTERFACE
      FUNCTION STAT (NAME, STATB)
      INTEGER STAT
      CHARACTER*(*), INTENT(IN) :: NAME
      INTEGER(4), INTENT(OUT) :: STATB(13)
      END FUNCTION STAT
      END INTERFACE

      INTERFACE
      FUNCTION STAT64 (NAME, STATB)
      INTEGER(4) STAT64
      CHARACTER*(*), INTENT(IN) :: NAME
      INTEGER(8), INTENT(OUT) :: STATB(13)
      END FUNCTION STAT64
      END INTERFACE

      INTERFACE
      FUNCTION SYMLNK (NAME1, NAME2)
      INTEGER(4) SYMLNK
      CHARACTER*(*), INTENT(IN) ::  NAME1
      CHARACTER*(*), INTENT(IN) ::  NAME2
      END FUNCTION SYMLNK
      END INTERFACE

      INTERFACE
      FUNCTION TIME ()
      INTEGER(8) TIME
      END FUNCTION TIME
      END INTERFACE

      INTERFACE
      FUNCTION UNLINK(NAME)
      INTEGER(4) UNLINK
      CHARACTER*(*), INTENT(IN) :: NAME
      END FUNCTION UNLINK
      END INTERFACE

      INTERFACE
      FUNCTION WAIT(STATUS)
      INTEGER(4) WAIT
      INTEGER(4), INTENT(OUT) :: STATUS
      END FUNCTION WAIT
      END INTERFACE
